## ros-humble-teleop-twist-joy 2.4.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(teleop_twist_joy)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)

find_package(geometry_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)

add_library(${PROJECT_NAME} SHARED src/teleop_twist_joy.cpp)
target_link_libraries(${PROJECT_NAME}
  ${geometry_msgs_TARGETS}
  rclcpp::rclcpp
  rclcpp_components::component
  ${sensor_msgs_TARGETS}
)

include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME} EXPORT_FILE_NAME ${PROJECT_NAME}/${PROJECT_NAME}_export.h)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
set_target_properties(${PROJECT_NAME} PROPERTIES EXPORT_HEADER_DIR "${CMAKE_CURRENT_BINARY_DIR}")

rclcpp_components_register_nodes(${PROJECT_NAME}
  "teleop_twist_joy::TeleopTwistJoy")

add_executable(${PROJECT_NAME}_node src/teleop_node.cpp)
target_link_libraries(${PROJECT_NAME}_node ${PROJECT_NAME})
set_target_properties(${PROJECT_NAME}_node
  PROPERTIES OUTPUT_NAME teleop_node PREFIX "")

install(TARGETS ${PROJECT_NAME}
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(TARGETS ${PROJECT_NAME}_node
  DESTINATION lib/${PROJECT_NAME})

install(DIRECTORY include/
  DESTINATION include/${PROJECT_NAME})

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}_export.h
  DESTINATION include/${PROJECT_NAME}/${PROJECT_NAME})

install(DIRECTORY launch config
  DESTINATION share/${PROJECT_NAME})

if(BUILD_TESTING)
  # Disable some broken tests for now
  set(ament_cmake_copyright_FOUND TRUE)
  set(ament_cmake_cpplint_FOUND TRUE)
  set(ament_cmake_uncrustify_FOUND TRUE)

  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  set(_teleop_twist_joy_launch_tests
    # Check axes and scaling.
    test/differential_joy_launch_test.py
    test/holonomic_joy_launch_test.py
    test/six_dof_joy_launch_test.py

    # Check enable and turbo button logic.
    test/no_enable_joy_launch_test.py
    test/turbo_enable_joy_launch_test.py
    test/only_turbo_joy_launch_test.py
    test/turbo_angular_enable_joy_launch_test.py

    test/no_require_enable_joy_launch_test.py
  )

  find_package(launch_testing_ament_cmake REQUIRED)
  foreach(_test_path ${_teleop_twist_joy_launch_tests})
    add_launch_test(${_test_path}
      APPEND_ENV PYTHONPATH=${CMAKE_CURRENT_SOURCE_DIR}/test
      TIMEOUT 10
    )
  endforeach()
endif()

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(export_${PROJECT_NAME})

ament_package()

=== debian/changelog ===
ros-humble-teleop-twist-joy (2.4.5-1jammy) jammy; urgency=high

  * Cleanup CMakeLists.txt. (#36 <https://github.com/ros2/teleop_twist_joy/issues/36>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 08 Jun 2023 00:00:00 -0000

ros-humble-teleop-twist-joy (2.4.4-1jammy) jammy; urgency=high

  * Install includes to include/${PROJECT_NAME} (#30 <https://github.com/ros2/teleop_twist_joy/issues/30>)
  * joy_vel argument (#29 <https://github.com/ros2/teleop_twist_joy/issues/29>)
  * Contributors: Raffaello Bonghi, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 07 Jun 2023 00:00:00 -0000

ros-humble-teleop-twist-joy (2.4.3-1jammy) jammy; urgency=high

  * Fix the launch file to use 'executable'. (#28 <https://github.com/ros2/teleop_twist_joy/issues/28>)
  * fix launch notation (#26 <https://github.com/ros2/teleop_twist_joy/issues/26>)
  * Contributors: Chris Lalancette, Shigeki Kobayashi

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 02 Aug 2021 00:00:00 -0000

ros-humble-teleop-twist-joy (2.4.2-1jammy) jammy; urgency=high

  * Update README to reflect changes to config parameters. (fixes #23 <https://github.com/ros2/teleop_twist_joy/issues/23>) (#24 <https://github.com/ros2/teleop_twist_joy/issues/24>)
  * Contributors: Josh Newans

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 18 Mar 2021 00:00:00 -0000

ros-humble-teleop-twist-joy (2.4.1-1jammy) jammy; urgency=high

  * Add parameter to enable/disable requiring the enable button to be held for motion (#21 <https://github.com/ros2/teleop_twist_joy/issues/21>)
  * Contributors: Chris Lalancette, kgibsonjca

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 01 Dec 2020 00:00:00 -0000

ros-humble-teleop-twist-joy (2.4.0-1jammy) jammy; urgency=high

  * Switch to modern ReadyToTest for the tests.
  * Switch from node_executable -> executable for Foxy.
  * Update README for Ros2 (#17 <https://github.com/ros2/teleop_twist_joy/issues/17>) (#18 <https://github.com/ros2/teleop_twist_joy/issues/18>)
  * Contributors: Chris Lalancette, nfry321

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 09 Nov 2020 00:00:00 -0000

ros-humble-teleop-twist-joy (2.3.0-1jammy) jammy; urgency=high

  * Make Parameters dynamic (#16 <https://github.com/ros2/teleop_twist_joy/issues/16>)
  * Contributors: aravindsrj

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 05 Aug 2020 00:00:00 -0000

ros-humble-teleop-twist-joy (2.2.2-1jammy) jammy; urgency=high

  * Export interfaces for Shared Lib on Windows.
  * Make teleop_twist_joy composable.
  * Reenable cppcheck.
  * Rename teleop_twist_joy.h to teleop_twist_joy.hpp
  * Get some basic tests running (#10 <https://github.com/ros2/teleop_twist_joy/issues/10>)
  * Port config and launch to ROS 2 (#11 <https://github.com/ros2/teleop_twist_joy/issues/11>)
  * Contributors: Chris Lalancette, Scott K Logan, seanyen

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-humble-teleop-twist-joy (2.2.0-1jammy) jammy; urgency=high

  * Fix parameters so things actually work in Dashing. (#9 <https://github.com/ros2/teleop_twist_joy/issues/9>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 31 May 2019 00:00:00 -0000

ros-humble-teleop-twist-joy (2.1.1-1jammy) jammy; urgency=high

  * Add in the ability to control via parameters (#8 <https://github.com/ros2/teleop_twist_joy/issues/8>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 08 Feb 2019 00:00:00 -0000

ros-humble-teleop-twist-joy (2.1.0-1jammy) jammy; urgency=high

  * ParameterService auto started (#7 <https://github.com/ros2/teleop_twist_joy/issues/7>)
  * Contributors: Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 26 Jun 2018 00:00:00 -0000

ros-humble-teleop-twist-joy (2.0.0-1jammy) jammy; urgency=high

  * Initial port to ROS2
  * Contributors: Chris Lalancette, Mikael Arguedas, Deanna Hood

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 08 Dec 2017 00:00:00 -0000

ros-humble-teleop-twist-joy (0.1.2-1jammy) jammy; urgency=high

  * Fixed incorrect key. (#21 <https://github.com/ros-teleop/teleop_twist_joy/issues/21>)
  * Allow custom config file from location outside of this package
  * Setting scale_angular_turbo if axis_angular is set so that turning works when turbo is pressed.
  * Added turbo scale for angular velocities and accompanying test.
  * Add LICENSE.txt.
  * Contributors: Daniel Aden, Isaac I.Y. Saito, Mike Purvis, Tony Baltovski

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 31 Aug 2016 00:00:00 -0000

ros-humble-teleop-twist-joy (0.1.1-1jammy) jammy; urgency=high

  * Add rostests.
  * Added maps to allow multi-dof velocity publishing.
  * Added Xbox 360 controller example.
  * Contributors: Mike Purvis, Tony Baltovski

 -- Chris Lalancette <clalancette@openrobotics.org>  Sat, 27 Jun 2015 00:00:00 -0000

ros-humble-teleop-twist-joy (0.1.0-1jammy) jammy; urgency=high

  * Added configurations for Logitech Attack3 and Extreme 3D Pro joysticks.
  * Initial version, with example config for PS3 joystick.
  * Contributors: Mike Purvis, Tony Baltovski

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 25 Jul 2014 00:00:00 -0000

=== debian/control ===
Source: ros-humble-teleop-twist-joy
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-geometry-msgs, ros-humble-launch-ros <!nocheck>, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-launch-testing-ros <!nocheck>, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-ros-workspace
Homepage: http://wiki.ros.org/teleop_twist_joy
Standards-Version: 3.9.2

Package: ros-humble-teleop-twist-joy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-geometry-msgs, ros-humble-joy, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-ros-workspace
Description: Generic joystick teleop for twist robots.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-teleop-twist-joy//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-teleop-twist-joy 2.4.7

=== debian/changelog ===
ros-humble-teleop-twist-joy (2.4.7-1bookworm) bookworm; urgency=high

  * Update the launch file to work with modern joy. (#52 <https://github.com/ros2/teleop_twist_joy/issues/52>) (#53 <https://github.com/ros2/teleop_twist_joy/issues/53>)
    It should use "device_id" (not "dev") as the parameter,
    and the parameter should be a number, not a path (this is
    effectively the SDL device number, which is cross-platform).
    (cherry picked from commit e4856e4afeda704547bdb43edc29d008b07f15d9)
    # Conflicts:
    #     README.md
    Co-authored-by: Chris Lalancette <mailto:clalancette@gmail.com>
  * Contributors: mergify[bot]

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 08 Sep 2024 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.6-1bookworm) bookworm; urgency=high

  * add inverted reverse param (#35 <https://github.com/ros2/teleop_twist_joy/issues/35>) (#43 <https://github.com/ros2/teleop_twist_joy/issues/43>)
    * add inverted-reverse param
    (cherry picked from commit 2a5f3e4f776869ae1e981f3ca1877cdf10318f37)
    # Conflicts:
    #     src/teleop_twist_joy.cpp
    Co-authored-by: Máté <mailto:56221639+turtlewizard73@users.noreply.github.com>
    Co-authored-by: Alejandro Hernández Cordero <mailto:ahcorde@gmail.com>
  * Add an option to publish TwistStamped (backport #42 <https://github.com/ros2/teleop_twist_joy/issues/42>) (#45 <https://github.com/ros2/teleop_twist_joy/issues/45>)
    * Add an option to publish TwistStamped (#42 <https://github.com/ros2/teleop_twist_joy/issues/42>)
    (cherry picked from commit 76cd6508a8c4e35d9fe3a6a8968abbe7159ffc08)
    # Conflicts:
    #     README.md
    #     src/teleop_twist_joy.cpp
    * resolved merge conflicts (#47 <https://github.com/ros2/teleop_twist_joy/issues/47>)
    Co-authored-by: Yannic Bachmann <mailto:yannic.bachmann@maha.de>
    ---------
    Co-authored-by: Tamaki Nishino <mailto:otamachan@gmail.com>
    Co-authored-by: Yannic Bachmann <mailto:76436302+YBachmann@users.noreply.github.com>
    Co-authored-by: Yannic Bachmann <mailto:yannic.bachmann@maha.de>
    Co-authored-by: Alejandro Hernández Cordero <mailto:ahcorde@gmail.com>
  * Added Humble CI (#50 <https://github.com/ros2/teleop_twist_joy/issues/50>)
  * Contributors: Alejandro Hernández Cordero, mergify[bot]

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 16 Jun 2024 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.5-1bookworm) bookworm; urgency=high

  * Cleanup CMakeLists.txt. (#36 <https://github.com/ros2/teleop_twist_joy/issues/36>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 07 Jun 2023 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.4-1bookworm) bookworm; urgency=high

  * Install includes to include/${PROJECT_NAME} (#30 <https://github.com/ros2/teleop_twist_joy/issues/30>)
  * joy_vel argument (#29 <https://github.com/ros2/teleop_twist_joy/issues/29>)
  * Contributors: Raffaello Bonghi, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 06 Jun 2023 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.3-1bookworm) bookworm; urgency=high

  * Fix the launch file to use 'executable'. (#28 <https://github.com/ros2/teleop_twist_joy/issues/28>)
  * fix launch notation (#26 <https://github.com/ros2/teleop_twist_joy/issues/26>)
  * Contributors: Chris Lalancette, Shigeki Kobayashi

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 01 Aug 2021 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.2-1bookworm) bookworm; urgency=high

  * Update README to reflect changes to config parameters. (fixes #23 <https://github.com/ros2/teleop_twist_joy/issues/23>) (#24 <https://github.com/ros2/teleop_twist_joy/issues/24>)
  * Contributors: Josh Newans

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 17 Mar 2021 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.1-1bookworm) bookworm; urgency=high

  * Add parameter to enable/disable requiring the enable button to be held for motion (#21 <https://github.com/ros2/teleop_twist_joy/issues/21>)
  * Contributors: Chris Lalancette, kgibsonjca

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 30 Nov 2020 16:00:00 -0000

ros-humble-teleop-twist-joy (2.4.0-1bookworm) bookworm; urgency=high

  * Switch to modern ReadyToTest for the tests.
  * Switch from node_executable -> executable for Foxy.
  * Update README for Ros2 (#17 <https://github.com/ros2/teleop_twist_joy/issues/17>) (#18 <https://github.com/ros2/teleop_twist_joy/issues/18>)
  * Contributors: Chris Lalancette, nfry321

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 08 Nov 2020 16:00:00 -0000

ros-humble-teleop-twist-joy (2.3.0-1bookworm) bookworm; urgency=high

  * Make Parameters dynamic (#16 <https://github.com/ros2/teleop_twist_joy/issues/16>)
  * Contributors: aravindsrj

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 04 Aug 2020 16:00:00 -0000

ros-humble-teleop-twist-joy (2.2.2-1bookworm) bookworm; urgency=high

  * Export interfaces for Shared Lib on Windows.
  * Make teleop_twist_joy composable.
  * Reenable cppcheck.
  * Rename teleop_twist_joy.h to teleop_twist_joy.hpp
  * Get some basic tests running (#10 <https://github.com/ros2/teleop_twist_joy/issues/10>)
  * Port config and launch to ROS 2 (#11 <https://github.com/ros2/teleop_twist_joy/issues/11>)
  * Contributors: Chris Lalancette, Scott K Logan, seanyen

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 22 Oct 2019 16:00:00 -0000

ros-humble-teleop-twist-joy (2.2.0-1bookworm) bookworm; urgency=high

  * Fix parameters so things actually work in Dashing. (#9 <https://github.com/ros2/teleop_twist_joy/issues/9>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 30 May 2019 16:00:00 -0000

ros-humble-teleop-twist-joy (2.1.1-1bookworm) bookworm; urgency=high

  * Add in the ability to control via parameters (#8 <https://github.com/ros2/teleop_twist_joy/issues/8>)
  * Contributors: Chris Lalancette



=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-teleop-twist-joy//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-teleop-twist-joy//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-teleop-twist-joy//opt/ros/humble/opt/teleop_twist_joy/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
